
// funktionen.c

#include "funktionen.h"


	//Funktionsprototypen
	void init_mcu (void);



//Mikrocontroller initialisieren 
void init_mcu (void)
{
	//Tasterpins (Pullups enable)
	DDRC &= ~((1<<PC0) | (1<<PC1));
	PORTC |= (1<<PC0) | (1<<PC1);
	DDRB &= ~((1<<PB6) | (1<<PB7));
	PORTB |= (1<<PB6) | (1<<PB7);
	
	//ADC (Prescaler = 8, externenal reference enable, interrupts enable) 
	ADCSRA |= (1<<ADEN) | (1<<ADIE) | (1<<ADPS0) | (1<<ADPS1);
	
	// Schaltausgnge & Anzeigenmultiplexer
	DDRC |= (1<<PC2) | (1<<PC3) | (1<<PC5);
	PORTC &= ~( (1<<PC2) | (1<<PC3) | (1<<PC5) );
	DDRB |= (1<<PB0) | (1<<PB1) | (1<<PB2);
	PORTB &= ~( (1<<PB0) | (1<<PB1) | (1<<PB2) );

	// Datenbus
	DDRD = 0xff;
	PORTD = 0;

	// Systemtimer
		
		// Zeitbasis 1ms (Timer2/CTC)
		TCCR2 |= (1<<CS21) | (1<<WGM21);
		TIMSK |= (1<<OCIE2);
		OCR2 = 125;

		// Zeitbasis
		TCCR0 |= (1<<CS01);
		TIMSK |= (1<<TOIE0);


	// Globale intterups enable
	sei();
}
