
// main.c

/*

	Schwellwertschalter mit 3 potentialfreien Relais-Schaltausgngen.
	Version	:	1V0
	Autor	:	Ingo Lhrig

*/


#include "main.h"
#include "funktionen.h"
#include "7-seg.h"

volatile uint16_t Zahl;
volatile uint16_t Kanal;
volatile uint16_t Debounce_up;
volatile uint16_t Debounce_down;
volatile uint16_t Debounce_left;
volatile uint16_t Debounce_ok;
volatile uint16_t Values[8];
volatile uint16_t Parameter;
volatile uint16_t Status;
volatile uint16_t u_ist;
volatile uint32_t Result;
volatile uint32_t u_buffer;
volatile uint16_t temp;


//Hauptschleife
int main (void)
{
 temp = 300;
  Status = ENTERED;
  Values[7] = 0;
  Parameter = 6;
  Kanal = 2;
  init_mcu();
  Values[6] = 300;

  while (1)
  {	
	
	if ( (!(PINC & (1<<OK))) && (Debounce_ok ==0) ) 
	{
		Debounce_ok = 200; 	
		if (Status) {Status = STEPPED_OUT;}
		else {Status = ENTERED;}
	}
	/////////////////////////////////////////////////////
	if ( (!(PINC & (1<<LEFT))) && (Debounce_left ==0) ) 
	{
		Debounce_left = 200;
		// weitere Verwendung???
	}
	/////////////////////////////////////////////////////
	if ( (!(PINB & (1<<UP))) && (Debounce_up ==0) ) 
	{
		Debounce_up = 200;
		if (Status== STEPPED_OUT) Parameter++;
		if (Parameter >= 8) {Parameter = 0;} 	
		if (Status== ENTERED)
		{
			if((Parameter == 7)&& (Values[Parameter] == 0)){Values[Parameter]++;}		
			else if (Parameter == 6) {;}
			else if (Parameter < 6) {Values[Parameter]++;}
		}
		
	}
	/////////////////////////////////////////////////////
	if ( (!(PINB & (1<<DOWN))) && (Debounce_down ==0) ) 
	{
		Debounce_down = 200;
		if (Status== STEPPED_OUT) {Parameter--;}
		if (Parameter>= 8) {Parameter = 7;}
		if (Status== ENTERED) 
		{
			if((Parameter == 7)&& (Values[Parameter] >= 1)){Values[Parameter]--;}		
			else if (Parameter == 6) {;}
			else if (Parameter < 6) {Values[Parameter]--;}
		}
	}

  }

}



//Interrupt fr Systemtimer
ISR (TIMEBASE_1MS)
{
	static uint8_t count = 0;
	count++;
	if (count%4==1) {ADCSRA |= (1<<ADSC);}

	if (Values[7] == 1) {ADMUX = U_500; Values[6] = u_ist/10; Kanal = 0;}
	if (Values[7] == 0) {ADMUX = U_70; Values[6] = u_ist; Kanal = 2;}

	
	
	// Taster entprellen
	if (Debounce_left) 	{Debounce_left--;}	
	if (Debounce_ok) 	{Debounce_ok--;}
	if (Debounce_up)	{Debounce_up--;}
	if (Debounce_down) 	{Debounce_down--;}
	
	// Displayausgabe
	if (count%2048==1) {Zahl++;}
	if (Status == ENTERED) 		{Display_Data(Values[Parameter],Kanal);}
	if (Status == STEPPED_OUT) 	{Display_Menue(Parameter);}
}



// Interrupt fr ADC Wandlung fertig
ISR (ADC_FINISHED)
{
	Result = ADC;	
	//Messbereich bis 85V
	if (ADMUX==U_70)
	{
	u_ist = (Result*425)/512;
	//u_buffer = (Result * 425)/512;
	//u_ist = ((15*u_ist) + u_buffer)/16;
	}
	
	if (ADMUX==U_500)
	{
	u_ist = (Result*5025)/1024;
	//u_buffer = (Result*5025)/1024;
	//u_ist = ((15*u_ist)+u_buffer)/16;
	}

}



